#pragma once

#include "ofMain.h"
#include "particle.h"
#include "ofxOsc.h"
#include "ofxGui.h"

//OSC Reciever PORT & HOST IP
#define PORT 12345
#define HOST "172.20.10.2"

class ofApp : public ofBaseApp {

public:
	void setup();
	void update();
	void draw();

	void keyPressed(int key);
	void keyReleased(int key);
	void mouseMoved(int x, int y);
	void mousePressed(int x, int y, int button);
	void mouseReleased(int x, int y, int button);

private:
	
	// OSC Receiver

	string oscMsg;
	ofxOscReceiver  receiver;
	float timeSent, timeReceived;

	int nBlobs;
	int blobCount;

	float xOfCentroid;
	float yOfCentroid;

	vector<thParticle*> system;
	vector<Attractor*> attractors;
	float birthCount;
	double time;

};
